/* OJO - PAGINA NO SE USA PERO NO ELIMINAR */
<template>
  <div>
    <div class="padding-top">
      <el-header height="110px" style="margin: 0 12rem;">
        <ReturnButton v-on:clickEvent="verifyEditModal" :offsetArrow="20" :spanTitle="3" title="Ir a Programas" class="text-end"></ReturnButton>
        <!-- Modal boton de regresar  -->

        <AppModal :show-dialog.sync="returnButtonModal"   v-if="returnButtonModal" nameClass="dialog-red" sizeImg="80%"  :rutImg="require(`../../assets/images/alerta.svg`)"  textBold="¿Estás seguro? " 
          :parrafo="' Si sales del formulario, la información se perderá.'"
          classBtn1="border-red" typeBtn1="danger" btn1="Salir" btn2="Seguir aquí " v-on:btnEvent="returnButtonModal = false"  @btnEvent="viewListPrograms" v-on:eventBtn="returnButtonModal = false">
        </AppModal>

        <el-col :span="24" style="padding-top: 1.5rem">
          <el-card :body-style="{ padding: '10px' }" shadow="never" class="bg-form text-white title-views">Editar Programa</el-card>
        </el-col>
      </el-header>
      <!-- FORMULARIO EDITAR PROGRAMA -->
      <el-main style="margin: 3rem 12.5rem">
        <el-form :rules="rules" ref="program" :model="program">
          <!-- titulo -->
          <h4 class="text-orange" style="margin-bottom:2rem">TÍTULO DEL PROGRAMA</h4>
          <el-row>
            <el-col :span="23" :offset="1">
              <el-form-item label="Título:" prop="programTitle" class="inputTitle">
                <el-input v-model="program.programTitle" size="small"></el-input>
              </el-form-item>
            </el-col>
          </el-row>

          <hr style="margin:2.5rem 0">
          <h4 class="text-orange" style="margin-bottom:2rem">CARACTERÍSTICAS DEL PROGRAMA</h4>
          <el-row type="flex" align="middle">
            <el-col :span="12" :offset="1">
              <el-form-item label="Tipo de Contenido:" prop="typeOfContent" class="inputTitle">
       
                <el-select @change="generateCodeTypeCont(program.typeOfContent)" v-model="program.typeOfContent"  placeholder="Seleccionar" size="small"  style="width: 100%;">
                  <el-option
                    v-for="typeOfContent in optionsTypeOfContent"
                    :key="typeOfContent.label"
                    :label="typeOfContent.label"
                    :value="typeOfContent.label">
                  </el-option>
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>




          <hr style="margin-top:2.5rem">
          <!-- VIGENCIA -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">VIGENCIA</h4>
          <el-row>
            <!-- INICIO DE VIGENCIA  -->
            <el-col :span="11" :offset="1">
              <el-form-item prop="validity[0].startValidity" label="Inicio:" class="selectInput">
                <el-date-picker
                  v-model="program.validity[0].startValidity" type="date" placeholder="Seleccionar"
                  format="dd/MM/yyyy" size="small" @input="validateEndDate"> 
                </el-date-picker>      
              </el-form-item>
            </el-col>
            <!-- FIN DE VIGENCIA -->
            <el-col :span="11" :offset="1">
              <el-form-item prop="validity[0].endValidity" label="Fin:" class="selectInput">
                <el-date-picker
                  v-model="program.validity[0].endValidity" type="date" placeholder="Seleccionar"
                  format="dd/MM/yyyy" size="small" :picker-options="datePickerOptions"> 
                </el-date-picker>     
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- HORARIO DEL PROGRAMA -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">HORARIO DEL PROGRAMA</h4>
          <el-row style="margin-bottom:3rem">
            <el-col :span="11" :offset="1">
              <el-row type="flex" align="middle">
                <el-col :span="6">
                  <span class="font-general">Inicio:</span>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleStartHour" class="inputTitle">
                    <el-input size="small" v-model="program.scheduleStartHour" placeholder="00" v-on:keypress.native="isNumber" ref="jump4" @keyup.enter.native="$refs.jump1.focus" maxlength="2">
                      <template slot="append">hr</template>
                    </el-input>
                  </el-form-item>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleStartMin" class="inputTitle">
                    <el-input size="small" v-model="program.scheduleStartMin" placeholder="00" v-on:keypress.native="isNumber" ref="jump1" @keyup.enter.native="$refs.jump2.focus" maxlength="2">
                      <template slot="append">min</template>
                    </el-input>
                  </el-form-item>
                </el-col>
              </el-row>
            </el-col>

            <el-col :span="11" :offset="1">
              <el-row type="flex" align="middle">
                <el-col :span="6">
                  <span class="font-general">Fin:</span>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleEndHour" class="inputTitle">
                    <el-input size="small" v-model="program.scheduleEndHour" placeholder="00" v-on:keypress.native="isNumber" ref="jump2" @keyup.enter.native="$refs.jump3.focus" maxlength="2">
                      <template slot="append">hr</template>
                    </el-input>
                  </el-form-item>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleEndMin" class="inputTitle">
                    <el-input size="small" v-model="program.scheduleEndMin" placeholder="00" v-on:keypress.native="isNumber" ref="jump3" @keyup.enter.native="$refs.jump4.focus" maxlength="2">
                      <template slot="append">min</template>
                    </el-input>
                  </el-form-item>
                </el-col> 
              </el-row>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- DIAS DE TRANSMISION -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">DÍAS DE TRANSMISIÓN</h4>
          <el-row type="flex" align="middle">
            <el-col :span="23" :offset="1">
              <el-form-item prop="transmissionDays">
                <el-radio-group v-model="transmission" @change="weeksChange" style="margin-bottom:1.6rem">
                  <el-radio :label="3" style="margin-right:2rem">Todos los días</el-radio>
                  <el-radio :label="6" style="margin-right:2rem">Lunes a Viernes</el-radio>
                  <el-radio :label="9" style="margin-right:2rem">Sábados y Domingos</el-radio>
                </el-radio-group>
                <el-checkbox-group v-model="program.transmissionDays" @change="handleCheckedDaysChange">
                  <el-checkbox-button v-for="day in days" :label="day" :key="day">{{day}}</el-checkbox-button>
                </el-checkbox-group>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- Sección de Canal de transmisión -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">CANAL DE TRANSMISIÓN</h4>
          <el-row style="margin-bottom: 1rem">
            <el-col :span="6" :offset="1">     
              <el-checkbox-group v-model="program.checkedChanels">
                <el-checkbox v-for="channel in channels" :label="channel" :key="channel" style="display: block; margin:1rem 0 2rem 0;">
                  <div>{{channel}}</div>
                </el-checkbox>
              </el-checkbox-group>
            </el-col>
          </el-row>

          <!-- SEÑALES -->         
          <h4 class="text-orange" style="margin: 3rem 0 2rem">SEÑALES</h4>
          <el-row style="margin: 0.7rem 0 1rem">          
            <el-col :span="6">
              <el-checkbox :indeterminate="isIndeterminate" v-model="checkAll" @change="handleCheckAllChange" border>Todas las señales</el-checkbox>
            </el-col>
            <el-col :span="6"><el-button @click="signalModal = true">Seleccionar</el-button></el-col>
            <!-- Modal -->
            <el-dialog
              :visible.sync="signalModal"
              width="40%"
              center
              :close-on-press-escape="false"
              custom-class="dialog-orange">
              <el-form-item style="margin: 0" prop="checkedSignals">
                <el-checkbox-group v-model="program.checkedSignals" @change="handleCheckedSignalsChange" class="text-center" style="margin-left: 3rem;">
                  <el-checkbox  v-for="signal in signals" :label="signal" :key="signal" style="width: 30%; margin: 0" class="text-start">{{signal}}</el-checkbox>
                </el-checkbox-group>              
              </el-form-item>
              <span slot="footer">
                <el-button v-on:click="updatingSignals" @click="signalModal = false" class="border-orange text-orange" style="margin: 0 16rem 1rem 0">Aceptar</el-button>
              </span>
            </el-dialog>
          </el-row>
          <el-form-item style="margin: 2rem 0 3rem" prop="checkedSignals">
            <div class="bg-gray" style="height: 8rem; padding:10px 7px 0">
              <el-col v-for="(item, j) in  program.checkedSignals" :key="j" 
                class="bg-white" style="margin:7px; padding:0 5px;width:5.5rem">{{item}} </el-col>
            </div>
          </el-form-item>
           <!-- boton actualizar -->
          <div class="text-end">
            <el-button v-on:click="modalCancelButton = true" class="text-orange border-orange">CANCELAR</el-button>
            <!-- <el-button @click="updatedProgram" type="primary">ACTUALIZAR</el-button> -->
            <el-button @click="submitForm('program')" type="primary">ACTUALIZAR</el-button>
          </div>

          <!-- Modal botón cancelar -->
          <AppModalDanger :show-dialog.sync="modalCancelButton"   v-if="modalCancelButton" v-on:btnEvent="viewListPrograms"  @btnEvent="modalCancelButton = false" v-on:eventBtn="modalCancelButton = false">
          </AppModalDanger>

          <!-- Modal checkCrosses -->   <!-- verificar funcionalidad del modal, no se visualiza en que momento se dispara el modal -->
          <el-dialog
            :visible.sync="checkCrossesModal"
            width="35%"
            :close-on-press-escape="false"
            :show-close="false"
            custom-class="dialog-orange">
            <el-row>
              <el-col :span="5">
                <img src="../../assets/images/pensante.svg" alt="emoticon" width="80%">
              </el-col>
              <el-col :span="18" :offset="1">
                <p class="subtitle-styles line-height: 22px">¡Espera!</p>
                <p style="line-height: 22px">Este programa ocupará:</p>
                <p style="line-height: 22px"
                  v-for="(item, index) in arrCheckCrosses"
                  :key="index">
                  <span>{{item.time}} de <strong>"{{item.title}}"</strong></span>
                </p>
                <div class="text-end" style="margin-top: 3rem">
                  <el-button @click="checkCrossesModal = false" v-on:click="cleanArrcheckCrosses" class="border-orange text-orange" plain>CANCELAR</el-button>
                  <el-button @click="checkCrossesModal = false" v-on:click="updatedProgram" type="primary">ACEPTAR</el-button>              
                </div>
              </el-col>
            </el-row>
          </el-dialog>

          <!-- MODAL DE FORMULARIO INVALIDO -->
          <AppModal :show-dialog.sync="invalidForm" v-if="invalidForm" nameClass="dialog-red" 
            :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%"  
            :parrafo="'Por favor, ingrese todos los campos requeridos.'">
          </AppModal>

        </el-form>
      </el-main>
    </div>
  </div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import AppModal from '@/components/AppModal.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import { restTimes } from '../../utils/calculateTime.js'
import { validateTime } from '@/utils/calculateTime.js'
import { HTTP } from '../../main.js'

const allWeek = ["Lunes", "Martes", "Miércoles", "Jueves", "Viernes", "Sábado", "Domingo"];
const week = ["Lunes", "Martes", "Miércoles", "Jueves", "Viernes"];
const weekend = ["Sábado", "Domingo"];

String.prototype.toProperCase = function () {
  const re = /(^|[^A-Za-zÁÉÍÓÚÜÑáéíóúüñ])(?:([a-záéíóúüñ])|([A-ZÁÉÍÓÚÜÑ]))|([A-ZÁÉÍÓÚÜÑ]+)/gu;
  return this.replace(re,
        (m, caracterPrevio, minuscInicial, mayuscInicial, mayuscIntermedias) => {
            const locale = ['es', 'gl', 'ca', 'pt', 'en'];
            if (mayuscIntermedias)
                return mayuscIntermedias.toLocaleLowerCase(locale);
            return caracterPrevio
                 + (minuscInicial ? minuscInicial.toLocaleUpperCase(locale) : mayuscInicial);
        });
};

Array.prototype.containsArray = function (array) {
  if (arguments[1]) {
    var index = arguments[1], last = arguments[2];
  } else {
    var index = 0, last = 0; this.sort(); array.sort();
  };
  
  return index == array.length
      || ( last = this.indexOf( array[index], last ) ) > -1
      && this.containsArray( array, ++index, ++last );                      
};

export default {
  components: {
    ReturnButton,
    AppModal,
    AppModalDanger
  },
  data () {
    return { 
      codeTypeContent: '', 
      channels: ['América TV', 'América Next'], 
      signalsTable: [], //Desde DB
      programTypeTable: [],
      idEdit: JSON.parse(this.$localStorage.get('programId')),
      transmission: [],
      days: allWeek,
      laboralDays: week,
      weekend: weekend,
      isIndeterminate: true,
      checkAll: false,
      signalModal: false,
      addProgramModal: false,
      returnButtonModal: false,
      validityStart:"00/00/00",
      datePickerOptions: {
        disabledDate: this.disabledValidityDate
      },
      modalCancelButton:false,
      checkCrossesModal: false,
      arrCheckCrosses: [],
      crushedPrograms: [],
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      contador: 0,
      codigoDias: [],
      numberWeek: [2, 3, 4, 5, 6, 7, 1],
      signalsByCode: '',
      arrSignalsCode: [],
      program: {
        programTitle: "",
        transmissionDays: [],
        transmissionDaysDescription: "",
        checkedSignals: [],
        checkedSignalsDescription: '',
        scheduleStartHour:"",
        scheduleStartMin:"",
        scheduleEndHour:"",
        scheduleEndMin:"",
        validity: [
          { startValidity: '',
            endValidity: ''}
        ], 
        typeOfContent: '',
        checkedChanels: ''
      },
      rules: {
        typeOfContent: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        programTitle: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        validity: [
          { 
            startValidity: [{ required: true, message: 'Por favor seleccione un valor', trigger: 'change' }],
            endValidity: [{ required: true, message: 'Por favor seleccione un valor', trigger: 'change' }]
          }
        ],
        scheduleStartHour: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleStartMin: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleEndHour: [
          { required: true, max:24, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleEndMin: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        transmissionDays: [
          { required: true, message: 'Por favor seleccione los días de transmisión', trigger: 'change' },
        ],
        checkedSignals: [
          { required: true, message: 'Por favor seleccione las señales', trigger: 'change' },
        ]
      },
      invalidForm: '',
      optionsTypeOfContent: [
        {
          value: 'AG',
          label: 'Agrícolas'
        },
           {
          value: 'BE',
          label: 'Concursos de belleza'
        },
           {
          value: 'CN',
          label: 'Concurso'
        },
           {
          value: 'CO',
          label: 'Cómicos'
        },
           {
          value: 'DE',
          label: 'Deportivos'
        },
          {
          value: 'DF',
          label: 'Documental'
        },
          {
          value: 'DG',
          label: 'Tv digital'
        },
         {
          value: 'DM',
          label: 'Desfile militar'
        },
         {
          value: 'ELE',
          label: 'Electorales'
        },
         {
          value: 'EN',
          label: 'Entrevistas'
        },
         {
          value: 'ENT',
          label: 'Entretenimiento'
        },
         {
          value: 'ES',
          label: 'Especiales'
        },
         {
          value: 'FC',
          label: 'Cocina'
        },
        {
          value: 'FE',
          label: 'Ferias'
        },
         {
          value: 'FM',
          label: 'Femeninos'
        },
         {
          value: 'HI',
          label: 'Himno nacional'
        },
        {
          value: 'ID',
          label: 'Dibujos'
        },
         {
          value: 'IP',
          label: 'Infantiles (Programas)'
        },
         {
          value: 'ME',
          label: 'Musical y entrevista'
        },
         {
          value: 'MG',
          label: 'Magazine'
        },
        {
          value: 'MIC',
          label: 'Micro programas'
        },

        {
          value: 'MS',
          label: 'Miniseries'
        },
         {
          value: 'MU',
          label: 'Musicales'
        },
         {
          value: 'NA',
          label: 'Ninguna anterior'
        },
        {
          value: 'NO',
          label: 'Noticieros'
        },
            {
          value: 'PA',
          label: 'Largometraje'
        },
         {
          value: 'PE',
          label: 'Periodísticos'
        },
         {
          value: 'PO',
          label: 'Políticos'
        },
        {
          value: 'PTEC',
          label: 'Programa tecnológicos'
        },
           {
          value: 'RE',
          label: 'Religiosos'
        },
           {
          value: 'RV',
          label: 'Revistas'
        },
           {
          value: 'SA',
          label: 'Series'
        },
           {
          value: 'SAL',
          label: 'Salud'
        },
           {
          value: 'TEL',
          label: 'Teleserie'
        },
        {
          value: 'TN',
          label: 'Telenovelas'
        },
        {
          value: 'TS',
          label: 'Talk show'
        },

      ],
    };
  },
  computed: {
    verifyChangeModal () {
      if (this.program.programTitle) {
         const array = [
          this.program.programTitle,
          this.program.transmissionDays.length,
          this.program.transmissionDaysDescription,
          this.program.checkedSignals.length,
          this.program.checkedSignalsDescription,
          this.program.scheduleStartHour,
          this.program.scheduleStartMin,
          this.program.scheduleEndHour,
          this.program.scheduleEndMin, 
          this.program.validity[0].startValidity,
          this.program.validity[0].endValidity
          ].join()
          return array
      }
    },
    signals () {
      let dataTables = this.$store.state.tables;
      for (let i = 0; i < dataTables.length; i++) {
        if (dataTables[i].tableName === 'signals') {
          this.signalsTable = dataTables[i].types
          this.signalsByCode = dataTables[i].description
          return dataTables[i].types
        }
      }
    }
  },
  created () {
    this.fetchProgram() 
    // this.getPrograms()
    this.getTables()
    this.gettingUsername()
  },
  methods: {
    gettingUsername(){
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
    generateCodeTypeCont (val) {
      this.optionsTypeOfContent.map((el, i, arr) => {
        if( el.label == val ) {
          this.codeTypeContent = el.value
        }
      })
    },
    verifyEditModal () {
      if(this.contador > 1) {
        this.returnButtonModal = true
      }
      else {
        this.$router.push({name: 'programs'})
      }
    },
    getTables () {
      let dataType = 'tables';
      this.$store.dispatch("getData", dataType);
    },
    // getPrograms () {
    //   let dataType = 'programs';
    //   this.$store.dispatch("getData", dataType);
    // },
    fetchProgram () {
      const programId = JSON.parse(this.$localStorage.get('programId'));
      HTTP.get(`programs/`+ programId)
        .then(res => {
          
          console.log(res.data.program, 'res.data.program')
          this.program = res.data.program;
          this.codeTypeContent = res.data.program.codeTypeContent
          console.log(this.codeTypeContent, 'codeTypeContent RES')
          // DATE OF START VALIDITY
          let startValidity = this.program.validity[0].startValidity.split("/")
          let newStartValidity = startValidity[1]+'/'+startValidity[0]+'/'+startValidity[2]
          this.program.validity[0].startValidity = new Date(newStartValidity).getTime()
          // DATE OF END VALIDITY
          let endValidity = this.program.validity[0].endValidity.split("/")
          let newEndValidity = endValidity[1]+'/'+endValidity[0]+'/'+endValidity[2]
          this.program.validity[0].endValidity = new Date(newEndValidity).getTime()
          this.codigoDias = res.data.program.codeDays
          this.arrSignalsCode = res.data.program.signalsCode
          this.handleCheckedDaysChange(this.program.transmissionDays)
      })
      .catch(err => console.log(err))
    },
    convertHourDate (date, hours, minutes) {
      var d = new Date(date).toLocaleDateString('en-GB')
      var newString = d + ' ' + hours + ':' + minutes + ':' + '00'
      console.log(newString)
      return newString
      // var d = new Date(date)
      // d.setHours(hours)
      // d.setMinutes(minutes)
      // d.setSeconds(0)

      // return d 
    },
    updatedProgram () {
      console.log(this.codigoDias,'this.codigoDias')
      console.log(this.program,'this.program')
      if(this.program.checkedSignals.length === 13) {
        this.program.checkedSignalsDescription = 'Todas las señales'
      } else {
        this.program.checkedSignalsDescription = this.program.checkedSignals.join(', ').replace(/,(?=[^,]*$)/, ' y');
      }
      let transmissionDaysToFilter = this.program.transmissionDays;
      let missingDays = this.days.filter(function(obj) { return transmissionDaysToFilter.indexOf(obj) == -1; });
      let daysLeftover = this.days.filter(function(obj) { return missingDays.indexOf(obj) == -1; });
      this.program.transmissionDays = daysLeftover;

      if (this.program.scheduleStartHour.length === 1) {
        this.program.scheduleStartHour = "0" + this.program.scheduleStartHour;
      }
      if (this.program.scheduleStartMin.length === 1) {
        this.program.scheduleStartMin = "0" + this.program.scheduleStartMin;
      }
      if (this.program.scheduleEndHour.length === 1) {
        this.program.scheduleEndHour = "0" + this.program.scheduleEndHour;
      }
      if (this.program.scheduleEndMin.length === 1) {
        this.program.scheduleEndMin = "0" + this.program.scheduleEndMin;
      }
      if(this.program.transmissionDays.join() != this.laboralDays.join() && this.program.transmissionDays.length !== 7) {
        let description = this.program.transmissionDays.join(', ');
        this.program.transmissionDaysDescription = description.replace(/,(?=[^,]*$)/, ' y');
      }
      if(this.program.transmissionDays.join() == this.laboralDays.join()){
        this.program.transmissionDaysDescription = 'De Lunes a Viernes'
      }
      if(this.program.transmissionDays.join() == this.weekend.join()) {
        this.program.transmissionDaysDescription = 'Sábados y domingos'
      }
      if(this.program.transmissionDays.length === 7){
        this.program.transmissionDaysDescription = 'Todos los dias'
      } 
      
      let startValidity = new Date(this.program.validity[0].startValidity).toLocaleDateString('en-GB')
      let endValidity = new Date(this.program.validity[0].endValidity).toLocaleDateString('en-GB')
      // this.validity[0].startValidity = this.startValidityValue.toLocaleDateString('en-GB')
      // this.validity[0].endValidity = this.endValidityValue.toLocaleDateString('en-GB')
      let hoursInicio = this.convertHourDate(this.program.validity[0].startValidity, this.program.scheduleStartHour, this.program.scheduleStartMin)
      let hoursFin = this.convertHourDate(this.program.validity[0].endValidity, this.program.scheduleEndHour, this.program.scheduleEndMin)
      this.program.validity[0].startValidity = startValidity
      this.program.validity[0].endValidity = endValidity

      console.log(this.codeTypeContent, 'codeTypeContent')
      console.log(this.program.typeOfContent, 'typeOfContent')
      console.log(this.program.checkedChanels, 'this.program.checkedChanels')
      
      HTTP.patch('programs/' + this.idEdit,
        [
          { propName: "codeTypeContent", value: this.codeTypeContent },
          { propName: "typeOfContent", value: this.program.typeOfContent }, 
          { propName: "checkedChanels", value: this.program.checkedChanels }, 
          { propName: "programTitle", value: this.program.programTitle.toProperCase() },
          { propName: "programType", value: this.program.programType}, 
          { propName: "transmissionDays", value: this.program.transmissionDays}, 
          { propName: "transmissionDaysDescription", value: this.program.transmissionDaysDescription}, 
          { propName: "checkedSignals", value: this.program.checkedSignals.sort()}, 
          { propName: "checkedSignalsDescription", value: this.program.checkedSignalsDescription}, 
          { propName: "scheduleStartHour", value: this.program.scheduleStartHour}, 
          { propName: "scheduleStartMin", value: this.program.scheduleStartMin}, 
          { propName: "scheduleEndHour", value: this.program.scheduleEndHour}, 
          { propName: "scheduleEndMin", value: this.program.scheduleEndMin}, 
          { propName: "validity", value: this.program.validity}, //this.validity
          { propName: "userName", value: this.userName},
          { propName: "userEmail", value: this.userEmail},
          { propName: "codProgram", value: this.program.codProgram},
          { propName: "codeDays", value: this.codigoDias},
          { propName: "signalsCode", value: this.arrSignalsCode.sort()},
          { propName: "geminisCode", value: this.program.geminisCode},
          { propName: "vigencia", value: [{
            startValidity: hoursInicio,
            endValidity: hoursFin,
            hourStart: hoursInicio,
            hoursEnd: hoursFin
          }]},
        ]
      )
      .then(res => {
        let dataType = "programs"
        this.$store.dispatch("getData", dataType)
        this.$router.push({name: 'programs'});
      })
      .catch(err => {
        console.log(err)
      })
    },
    disabledValidityDate(time) {
      return time.getTime() < this.program.validity[0].startValidity
    },
    validateEndDate () {
      if (this.program.validity[0].startValidity > this.program.validity[0].endValidity) {
        this.program.validity[0].endValidity = this.program.validity[0].startValidity
      } 
    },
    weeksChange(val) {
      let arrCode = []
      let arrIndexCode
      if (this.transmission === 3) {
        this.program.transmissionDays = val ? allWeek : [];
        console.log(val);  
        arrIndexCode = this.arrayDiasCode(allWeek)
      } else if (this.transmission === 6) {
        this.program.transmissionDays = val ? week : [];
        arrIndexCode = this.arrayDiasCode(week)
      } else if (this.transmission === 9) {
        this.program.transmissionDays = val ? weekend : [];
        arrIndexCode = this.arrayDiasCode(weekend)
      }

      for(let r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.numberWeek[arrIndexCode[r]])
      }
      this.codigoDias = arrCode
      console.log(this.codigoDias, "this.codigoDias")
    },
    handleCheckedDaysChange(value) {
      if (value.length === 7) {
        this.transmission = 3
      } else if (value.sort().join() == weekend.sort().join()) {
        this.transmission = 9
      } else  if (value.sort().join() == week.sort().join()) {
        this.transmission = 6
      } else {
        this.transmission = []
      }

      let arrCode = []
      let arrIndexCode = this.arrayDiasCode(value)
      for(let r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.numberWeek[arrIndexCode[r]])
      }
      this.codigoDias = arrCode
      console.log(this.codigoDias, "this.codigoDias")
    },
    handleCheckAllChange (val) {
      this.program.checkedSignals = val ? this.signalsTable : [];
      this.isIndeterminate = false;

      let arrCode = []
      let arrIndexCode = this.arraySignalCode(this.signalsTable)
      for(var r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.signalsByCode[arrIndexCode[r]])
      }
      this.arrSignalsCode = arrCode
       console.log(this.arrSignalsCode, "arrSignalsCode")
    },
    updatingSignals () {
      let checkboxes = document.querySelectorAll(
        "input[type=checkbox]:checked"
      );
      let checkArrValue = [];
      for (var i = 0; i < checkboxes.length; i++) {
        checkArrValue.push(checkboxes[i].value);
      }
      let programEdit = this.program.checkedSignals;
      let daysEdit = this.days;
      var array3 = checkArrValue.filter(function(obj) { return programEdit.indexOf(obj) == -1; });
      var array4 = array3.filter(function(obj) { return daysEdit.indexOf(obj) == -1; });
      array4.map((el,i) => {
        this.program.checkedSignals.push(el);
      })
      console.log(this.program.checkedSignals);
    },
    handleCheckedSignalsChange (value) {
      let checkedCount = value.length;
      this.checkAll = checkedCount === this.signals.length;
      let arrCode = []

      let arrIndexCode = this.arraySignalCode(value)
      for(let r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.signalsByCode[arrIndexCode[r]])
      }
      this.arrSignalsCode = arrCode
      console.log(this.arrSignalsCode, "arrSignalsCode")
      this.isIndeterminate = checkedCount > 0 && checkedCount < this.signals.length;
    },
    arraySignalCode (val) {
      let arrayIndex = []
      for(var x=0; x<val.length; x++){
        for(var y=0; y<this.signals.length; y++){
          if(this.signals[y] == val[x]){
            arrayIndex.push(y)
          }
        }
      }
      return arrayIndex
    },
    arrayDiasCode (val) {
      let arrayIndex = []
      for(var x=0; x<val.length; x++){
        for(var y=0; y<this.days.length; y++){
          if(this.days[y] == val[x]){
            arrayIndex.push(y)
          }
        }
      }
      return arrayIndex
    },
    cleanAllInputs (program) {
      this.$refs[program].resetFields()
      this.transmission = [];
      this.isIndeterminate = true
      this.arrSignalsCode = []
    },
    viewListPrograms () {
      this.$router.push({name: 'programs'})
    },
    cleanArrcheckCrosses () {
      this.arrCheckCrosses = []
    },
    submitForm(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          this.checkCrosses()
        } else {
          this.invalidForm = true
          return false;
        }
      });
    },
    checkCrosses () {
      let allPrograms = this.$store.state.programs
      // 

      // Establecer estructura de Horario (02 hrs 09 min)
      if (this.program.scheduleStartHour.length === 1) {
        this.program.scheduleStartHour = "0" + this.program.scheduleStartHour;
      }
      if (this.program.scheduleStartMin.length === 1) {
        this.program.scheduleStartMin = "0" + this.program.scheduleStartMin;
      }
      if (this.program.scheduleEndHour.length === 1) {
        this.program.scheduleEndHour = "0" + this.program.scheduleEndHour;
      }
      if (this.program.scheduleEndMin.length === 1) {
        this.program.scheduleEndMin = "0" + this.program.scheduleEndMin;
      }

      // Comparar Vigencias
      for (let i = 0; i < allPrograms.length; i++) {
        let partsA = allPrograms[i].validity[0].startValidity.split("/")
        let partsB = allPrograms[i].validity[0].endValidity.split("/")
        let initialValue = partsA[1] + "/" + partsA[0] + "/" + partsA[2]; // Convirtiendo las fechas en formato MM/DD/YYYY, y string
        let finalValue = partsB[1] + "/" + partsB[0] + "/" + partsB[2]; // Convirtiendo las fechas en formato MM/DD/YYYY, y string

        // Obteniendo milisegundos 
        let initialValueMili = new Date(initialValue).getTime()
        let finalValueMili = new Date(finalValue).getTime()
        // let currentIniValMili = this.startValidityValue.getTime()
        // let currentFinValMili = this.endValidityValue.getTime()
        let currentIniValMili = this.program.validity[0].startValidity
        let currentFinValMili = this.program.validity[0].endValidity
        

        if (currentIniValMili > initialValueMili && currentFinValMili < finalValueMili) {

          // Comparar Días de transmisión
          if (allPrograms[i].transmissionDays.containsArray(this.program.transmissionDays)) {

            // Comparar Horarios
            let allStartTime = Number(allPrograms[i].scheduleStartHour + allPrograms[i].scheduleStartMin)
            let allEndTime = Number(allPrograms[i].scheduleEndHour + allPrograms[i].scheduleEndMin)
            let startTime = Number(this.program.scheduleStartHour + this.program.scheduleStartMin)
            let endTime = Number(this.program.scheduleEndHour + this.program.scheduleEndMin)

            let startTimeFormat  = '00:' + allPrograms[i].scheduleStartHour + ':' + allPrograms[i].scheduleStartMin
            let endTimeFormat = '00:' + allPrograms[i].scheduleEndHour + ':' + allPrograms[i].scheduleEndMin
            let startFormat = '00:' + this.program.scheduleStartHour + ':' + this.program.scheduleStartMin
            let endFormat = '00:' + this.program.scheduleEndHour + ':' + this.program.scheduleEndMin
            
            if (startTime < allEndTime && endTime > allStartTime) {

              // Obtengo el primer rango en el que se encuentra el horario de inicio
              if (startTime >= allStartTime && startTime < allEndTime) {
                if (allEndTime - allStartTime === allEndTime - startTime) {
                  this.crushedPrograms.push(allPrograms[i]._id)
                  this.arrCheckCrosses.push({title: allPrograms[i].programTitle, time: 'Todo el horario '})
                } else {
                  this.crushedPrograms.push(allPrograms[i]._id)
                  this.arrCheckCrosses.push({title: allPrograms[i].programTitle, time: restTimes(endTimeFormat, startFormat)})
                }
              }

              // Obtengo los rangos intermedios
              if (startTime < allStartTime && endTime > allEndTime) {
                this.arrCheckCrosses.push({title: allPrograms[i].programTitle, time: 'Todo el horario '})
                this.crushedPrograms.push(allPrograms[i]._id)
              }

              // Obtengo el último rango en el que se encuentra el horario de fin
              if (endTime > allStartTime && endTime <= allEndTime) {
                if (allEndTime - endTime === 0) {
                  // Condicional para eliminar item (id) duplicado
                  if (this.crushedPrograms.includes(allPrograms[i]._id)) {
                    console.log('Doble id eliminado')
                  } else {
                    this.crushedPrograms.push(allPrograms[i]._id)
                    this.arrCheckCrosses.push({title: allPrograms[i].programTitle, time: 'Todo el horario '})
                  }
                } else {
                  this.crushedPrograms.push(allPrograms[i]._id)
                  this.arrCheckCrosses.push({title: allPrograms[i].programTitle, time: restTimes(endFormat, startTimeFormat)})
                }
              }
            }
          }
        }
      }

      // Condicional para los modales
      if (this.arrCheckCrosses.length >= 1) {
        this.checkCrossesModal = true
      } else {
        this.updatedProgram()
      }
    },
    isNumber (evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }    
    }
  },
  watch: {
    verifyChangeModal(val) {
      
      this.contador += 1
    },
    'program.scheduleStartHour'(val) {
      this.program.scheduleStartHour = validateTime(val, 24)
    },
    'program.scheduleStartMin'(val) {
      this.program.scheduleStartMin = validateTime(val, 59)
    },
    'program.scheduleEndHour'(val) {
      this.program.scheduleEndHour = validateTime(val, 24)
    },
    'program.scheduleEndMin'(val) {
      this.program.scheduleEndMin = validateTime(val, 59)
    },
  }
}
</script>

